## boost1.40 1.40.0

=== CMakeLists.txt ===
##########################################################################
# CMake Build Rules for Boost                                            #
##########################################################################
# Copyright (C) 2007, 2008 Douglas Gregor <doug.gregor@gmail.com>        #
# Copyright (C) 2007, 2009 Troy Straszheim <troy@resophonic.com>         #
#                                                                        #
# Distributed under the Boost Software License, Version 1.0.             #
# See accompanying file LICENSE_1_0.txt or copy at                       #
#   http://www.boost.org/LICENSE_1_0.txt                                 #
##########################################################################
# Basic Usage:                                                           #
#                                                                        #
#   On Unix variants:                                                    #
#     ccmake BOOST_DIRECTORY                                             #
#                                                                        #
#     (c)onfigure options to your liking, then (g)enerate                #
#     makefiles. Use "make" to build, "make test" to test, "make         #
#     install" to install, and "make package" to build binary            #
#     packages.                                                          #
#                                                                        #
#   On Windows:                                                          #
#     run the CMake GNU, load the Boost directory, and generate          #
#     project files or makefiles for your environment.                   #
#                                                                        #
# For more information about CMake, see http://www.cmake.org             #
##########################################################################
cmake_minimum_required(VERSION 2.6.0 FATAL_ERROR)
project(Boost)

##########################################################################
# Version information                                                    #
##########################################################################

# We parse the version information from the boost/version.hpp header.
file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/boost/version.hpp BOOST_VERSIONSTR
  REGEX "#define[ ]+BOOST_VERSION[ ]+[0-9]+")
string(REGEX MATCH "[0-9]+" BOOST_VERSIONSTR ${BOOST_VERSIONSTR})
if (BOOST_VERSIONSTR)
  math(EXPR BOOST_VERSION_MAJOR "${BOOST_VERSIONSTR} / 100000")
  math(EXPR BOOST_VERSION_MINOR "${BOOST_VERSIONSTR} / 100 % 1000")
  math(EXPR BOOST_VERSION_SUBMINOR "${BOOST_VERSIONSTR} % 100")
  set(BOOST_VERSION "${BOOST_VERSION_MAJOR}.${BOOST_VERSION_MINOR}.${BOOST_VERSION_SUBMINOR}")
  message(STATUS "Boost version ${BOOST_VERSION}")
else()
  message(FATAL_ERROR 
    "Unable to parse Boost version from ${CMAKE_CURRENT_SOURCE_DIR}/boost/version.hpp")
endif()

# Make sure that we reconfigure when boost/version.hpp changes.
configure_file(boost/version.hpp
   ${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/version.stamp)
##########################################################################

# Put the libaries and binaries that get built into directories at the
# top of the build tree rather than in hard-to-find leaf
# directories. This simplifies manual testing and the use of the build
# tree rather than installed Boost libraries.
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

##########################################################################
# Boost CMake modules                                                    #
##########################################################################
list(APPEND CMAKE_MODULE_PATH ${Boost_SOURCE_DIR}/tools/build/CMake)
include(BoostUtils)
include(BoostConfig)
include(BoostCore)
include(BoostDocs)
include(CTest)
include(BoostTesting)
message(STATUS "Build name: ${BUILDNAME}")
##########################################################################

##########################################################################
# Build Features and Variants                                            #
##########################################################################

# Determine default settings for the variable BUILD_feature options
if (MSVC)
  set(BUILD_SINGLE_THREADED_DEFAULT OFF)
else ()
  set(BUILD_SINGLE_THREADED_DEFAULT OFF)
endif ()

# User-level options deciding which variants we will build. 
option(BUILD_STATIC "Whether to build static libraries" ON)
option(BUILD_SHARED "Whether to build shared libraries" ON)
option(BUILD_DEBUG "Whether to build debugging libraries" ON)
option(BUILD_RELEASE "Whether to build release libraries" ON)
option(BUILD_SINGLE_THREADED "Whether to build single-threaded libraries" 
       ${BUILD_SINGLE_THREADED_DEFAULT})
option(BUILD_MULTI_THREADED "Whether to build multi-threaded libraries" ON)

if(UNIX)
  option(BUILD_VERSIONED "Add versioning information to names of built files" OFF)
else(UNIX)
  option(BUILD_VERSIONED "Add versioning information to names of built files" ON)
endif(UNIX)

# For now, we only actually support static/dynamic run-time variants for 
# Visual C++. Provide both options for Visual C++ users, but just fix
# the values of the variables for all other platforms.
if(MSVC)
  option(BUILD_STATIC_RUNTIME "Whether to build libraries linking against the static runtime" ON)
  option(BUILD_DYNAMIC_RUNTIME "Whether to build libraries linking against the dynamic runtime" ON)
else(MSVC)
  set(BUILD_STATIC_RUNTIME OFF)
  set(BUILD_DYNAMIC_RUNTIME ON)
endif(MSVC)

# The default set of library variants that we will be building
boost_add_default_variant(RELEASE DEBUG)
boost_add_default_variant(STATIC SHARED)
boost_add_default_variant(SINGLE_THREADED MULTI_THREADED)
boost_add_default_variant(DYNAMIC_RUNTIME STATIC_RUNTIME)

# Extra features used by some libraries
set(BUILD_PYTHON_NODEBUG ON)
boost_add_extra_variant(PYTHON_NODEBUG PYTHON_DEBUG)
##########################################################################

##########################################################################
# Installation                                                           #
##########################################################################
if(BUILD_VERSIONED)
  if(BOOST_VERSION_SUBMINOR GREATER 0)
    set(BOOST_HEADER_DIR 
      "include/boost-${BOOST_VERSION_MAJOR}_${BOOST_VERSION_MINOR}_${BOOST_VERSION_SUBMINOR}")
  else(BOOST_VERSION_SUBMINOR GREATER 0)
    set(BOOST_HEADER_DIR 
      "include/boost-${BOOST_VERSION_MAJOR}_${BOOST_VERSION_MINOR}")  
  endif(BOOST_VERSION_SUBMINOR GREATER 0)
else(BUILD_VERSIONED)
  set(BOOST_HEADER_DIR "include/")
endif(BUILD_VERSIONED)
install(DIRECTORY boost 
  DESTINATION ${BOOST_HEADER_DIR}
  PATTERN "CVS" EXCLUDE
  PATTERN ".svn" EXCLUDE)
#
# TDS 20080526:  Getting a segfault here even with the ifs.   At r45780, with these lines 
# uncommented:
# 1. cmake the workspace
# 2. run ccmake and turn OFF BUILD_MULTI_THREADED and BUILD_SHARED
# 3. 'c' to configure
# 4. 'g' to generate.... segfault.
# 5. run rebuild_cache at the command line:  no segfault this time.
#
# With these lines commented out, step 4 above does not segfault.
#
#if (NOT TEST_INSTALLED_TREE)
  # If I don't have if around this, I get a seg fault
#  install(EXPORT boost-targets DESTINATION "lib/Boost${BOOST_VERSION}")
#endif (NOT TEST_INSTALLED_TREE)
##########################################################################

##########################################################################
# Binary packages                                                        #
##########################################################################
set(CPACK_PACKAGE_NAME "Boost")
set(CPACK_PACKAGE_VENDOR "Boost.org")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Boost ${BOOST_VERSION}")

if (EXISTS "${Boost_SOURCE_DIR}/README.txt")
  message(STATUS "Using generic cpack package description file.")
  set(CPACK_PACKAGE_DESCRIPTION_FILE "${Boost_SOURCE_DIR}/README.txt")
  set(CPACK_RESOURCE_FILE_README "${Boost_SOURCE_DIR}/README.txt")
endif ()

set(CPACK_RESOURCE_FILE_LICENSE "${Boost_SOURCE_DIR}/LICENSE_1_0.txt")
if (EXISTS "${Boost_SOURCE_DIR}/Welcome.txt")
  message(STATUS "Using generic cpack welcome file.")
  set(CPACK_RESOURCE_FILE_WELCOME "${Boost_SOURCE_DIR}/Welcome.txt")
endif()

set(CPACK_PACKAGE_VERSION "${BOOST_VERSION}")
set(CPACK_PACKAGE_VERSION_MAJOR "${BOOST_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${BOOST_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${BOOST_VERSION_SUBMINOR}")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "Boost")

if(WIN32 AND NOT UNIX)
  # There is a bug in NSI that does not handle full unix paths properly. Make
  # sure there is at least one set of four (4) backlasshes.
  # NOTE: No Boost icon yet
#  set(CPACK_PACKAGE_ICON "${Boost_SOURCE_DIR}/tools/build/CMake\\\\InstallIcon.bmp")
#  set(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\MyExecutable.exe")
  set(CPACK_NSIS_DISPLAY_NAME "Boost ${BOOST_VERSION_MAJOR}.${BOOST_VERSION_MINOR}.${BOOST_VERSION_SUBMINOR}")
  set(CPACK_NSIS_HELP_LINK "http:\\\\\\\\www.boost.org")
  set(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\www.boost.org")
  set(CPACK_NSIS_CONTACT "boost-users@lists.boost.org")
  set(CPACK_NSIS_MODIFY_PATH ON)
  
  # Encode the compiler name in the package 
  if (MSVC60)
    set(CPACK_PACKAGE_FILE_NAME "Boost-${BOOST_VERSION}-vc6")
    set(CPACK_NSIS_DISPLAY_NAME "${CPACK_NSIS_DISPLAY_NAME} for Microsoft Visual C++ 6")
  elseif (MSVC70)
    set(CPACK_PACKAGE_FILE_NAME "Boost-${BOOST_VERSION}-vc7")
    set(CPACK_NSIS_DISPLAY_NAME "${CPACK_NSIS_DISPLAY_NAME} for Microsoft Visual Studio 2002")
  elseif (MSVC71)
    set(CPACK_PACKAGE_FILE_NAME "Boost-${BOOST_VERSION}-vc71")
    set(CPACK_NSIS_DISPLAY_NAME "${CPACK_NSIS_DISPLAY_NAME} for Microsoft Visual Studio 2003")
  elseif (MSVC80)
    set(CPACK_PACKAGE_FILE_NAME "Boost-${BOOST_VERSION}-vc8")
    set(CPACK_NSIS_DISPLAY_NAME "${CPACK_NSIS_DISPLAY_NAME} for Microsoft Visual Studio 2005")    
  elseif (MSVC90)
    set(CPACK_PACKAGE_FILE_NAME "Boost-${BOOST_VERSION}-vc9")
    set(CPACK_NSIS_DISPLAY_NAME "${CPACK_NSIS_DISPLAY_NAME} for Microsoft Visual Studio 2008")
  elseif (BORLAND)
    set(CPACK_PACKAGE_FILE_NAME "Boost-${BOOST_VERSION}-borland")  
    set(CPACK_NSIS_DISPLAY_NAME "${CPACK_NSIS_DISPLAY_NAME} for Borland C++ Builder")    
  endif (MSVC60)
  set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${CPACK_NSIS_DISPLAY_NAME}")
endif(WIN32 AND NOT UNIX)
include(CPack)

option(BOOST_INSTALLER_ON_THE_FLY
       "Whether to build installers that download components on-the-fly" OFF)

if (BOOST_INSTALLER_ON_THE_FLY)
  if(COMMAND cpack_configure_downloads)
    cpack_configure_downloads(
    "http://www.osl.iu.edu/~dgregor/Boost-CMake/${BOOST_VERSION}/"
      ALL ADD_REMOVE)
  endif()
endif()

##########################################################################

##########################################################################
# Building Boost libraries                                               #
##########################################################################
# Always include the directory where Boost's include files will be.
if (TEST_INSTALLED_TREE)
  # Use the headers from the installation directory
  include_directories("${CMAKE_INSTALL_PREFIX}/${BOOST_HEADER_DIR}")
else (TEST_INSTALLED_TREE)
  # Use the headers directly from the Boost source tree (in boost/)
  include_directories(${Boost_SOURCE_DIR})
endif (TEST_INSTALLED_TREE)

# Boost.Build version 2 does this due to trouble with autolinking
# during building and testing.  
# TODO: See if we can actually use auto-linking in our regression tests.
add_definitions(-DBOOST_ALL_NO_LIB=1)

# Add build rules for documentation
add_subdirectory(doc)

=== doc/CMakeLists.txt ===
#
# Copyright Troy D. Straszheim
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
#
if (BUILD_DOCUMENTATION)
  add_subdirectory(src)
endif ()

=== libs/CMakeLists.txt ===
#
# Copyright Troy D. Straszheim
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
#
# Find each subdirectory containing a CMakeLists.txt file, and include
# it. This avoids the need to manually list which libraries in Boost
# have CMakeLists.txt files.

# return a list of directories that we should add_subdirectory()
macro(BOOST_COLLECT_SUBPROJECT_DIRECTORY_NAMES varname filename)
  file(GLOB BOOST_LIBRARY_CMAKE_FILES 
    RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "*/${filename}")
  foreach(BOOST_LIB_CMAKE_FILE ${BOOST_LIBRARY_CMAKE_FILES})
    get_filename_component(BOOST_LIB_DIR ${BOOST_LIB_CMAKE_FILE} PATH)
    set(${varname} ${${varname}} ${BOOST_LIB_DIR})
  endforeach(BOOST_LIB_CMAKE_FILE ${BOOST_LIBRARY_CMAKE_FILES})
endmacro(BOOST_COLLECT_SUBPROJECT_DIRECTORY_NAMES varname)

macro(ADD_SUBDIRECTORIES prefix)
  foreach(subdir ${ARGN})
    message(STATUS "${prefix}${subdir}")
    add_subdirectory(${subdir})
  endforeach(subdir ${ARGN})
endmacro(ADD_SUBDIRECTORIES prefix)

# Find all of the subdirectories with .cmake files in them. These are
# the libraries with dependencies.
boost_collect_subproject_directory_names(BOOST_MODULE_DIRS "module.cmake")
foreach(subdir ${BOOST_MODULE_DIRS})
  include("${CMAKE_CURRENT_SOURCE_DIR}/${subdir}/module.cmake")
endforeach(subdir)

# Find all of the subdirectories with CMakeLists.txt files in
# them. This contains all of the Boost libraries.
boost_collect_subproject_directory_names(BOOST_SUBPROJECT_DIRS "CMakeLists.txt")

# Add all of the Boost projects in reverse topological order, so that
# a library's dependencies show up before the library itself.
set(CPACK_INSTALL_CMAKE_COMPONENTS_ALL)
list(SORT BOOST_SUBPROJECT_DIRS)
topological_sort(BOOST_SUBPROJECT_DIRS BOOST_ _DEPENDS)
add_subdirectories(" + " ${BOOST_SUBPROJECT_DIRS})

# Write out a GraphViz file containing inter-library dependencies. 
set(BOOST_DEPENDENCY_GRAPHVIZ_FILE "${Boost_BINARY_DIR}/dependencies.dot")
file(WRITE ${BOOST_DEPENDENCY_GRAPHVIZ_FILE} "digraph boost {\n")
foreach(SUBDIR ${BOOST_SUBPROJECT_DIRS})
  string(TOUPPER "BOOST_${SUBDIR}_COMPILED_LIB" BOOST_COMPILED_LIB_VAR)
  if (${BOOST_COMPILED_LIB_VAR})
    file(APPEND ${BOOST_DEPENDENCY_GRAPHVIZ_FILE} "  \"${SUBDIR}\" [style=\"filled\" fillcolor=\"#A3A27C\" shape=\"box\"];\n ")
  endif (${BOOST_COMPILED_LIB_VAR})
  string(TOUPPER "BOOST_${SUBDIR}_DEPENDS" DEPENDS_VAR)
  if(DEFINED ${DEPENDS_VAR})
    foreach(DEP ${${DEPENDS_VAR}})
      file(APPEND ${BOOST_DEPENDENCY_GRAPHVIZ_FILE} 
        "  \"${SUBDIR}\" -> \"${DEP}\";\n")
    endforeach()
  endif()
endforeach()
file(APPEND ${BOOST_DEPENDENCY_GRAPHVIZ_FILE} "  \"test\" [style=\"filled\" fillcolor=\"#A3A27C\" shape=\"box\"];\n ")
file(APPEND ${BOOST_DEPENDENCY_GRAPHVIZ_FILE} "}\n")

=== tools/CMakeLists.txt ===
#
# Copyright Troy D. Straszheim
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
#
# return a list of directories that we should add_subdirectory()
macro(boost_collect_lib_dependencies varname filename)
  #message(STATUS "boost_collect_lib_dependencies.... ${Boost_SOURCE_DIR}/libs")
  file(GLOB BOOST_LIBRARY_CMAKE_FILES 
       RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${Boost_SOURCE_DIR}/libs/*/${filename}")
  foreach(BOOST_LIB_CMAKE_FILE ${BOOST_LIBRARY_CMAKE_FILES})
    #message(STATUS "-- BOOST_LIB_CMAKE_FILE: ${BOOST_LIB_CMAKE_FILE}")
    get_filename_component(BOOST_LIB_DIR ${BOOST_LIB_CMAKE_FILE} PATH)
    set(${varname} ${${varname}} ${BOOST_LIB_DIR})
  endforeach(BOOST_LIB_CMAKE_FILE ${BOOST_LIBRARY_CMAKE_FILES})
endmacro(boost_collect_lib_dependencies varname)


# Find all of the subdirectories with .cmake files in them. These are
# the libraries with dependencies.
boost_collect_lib_dependencies(BOOST_MODULE_DIRS "module.cmake")
foreach(subdir ${BOOST_MODULE_DIRS})
#  message(STATUS "${Boost_SOURCE_DIR}/libs/${subdir}/module.cmake")
  include("${Boost_SOURCE_DIR}/libs/${subdir}/module.cmake")
endforeach(subdir)


###############################################################################
# This macro is an internal utility macro 
# TODO: Document this if it stays around
#
#
# example usage:
#  boost_tool_dependencies( BOOST_DEPENDS test)
#
macro(boost_tool_dependencies)
  parse_arguments(BOOST_TEST 
    "BOOST_DEPENDS"
    ""
    ${ARGN}
  )
    set (THIS_TEST_DEPENDS_ALL "")
    # message (STATUS "BOOST_TEST_BOOST_DEPENDS: ${BOOST_TEST_BOOST_DEPENDS}")
    foreach(libname ${BOOST_TEST_BOOST_DEPENDS})
       # message(STATUS "libname: ${libname}")
        string(TOUPPER "BOOST_${libname}_DEPENDS" THIS_PROJECT_DEPENDS)
      #  message(STATUS "${THIS_PROJECT_DEPENDS}: ${${THIS_PROJECT_DEPENDS}}")
       # set(THIS_TEST_DEPENDS_ALL ${libname} ${${THIS_PROJECT_DEPENDS}} )
      #  message(STATUS "${THIS_TEST_DEPENDS_ALL}: ${${THIS_TEST_DEPENDS_ALL}}")
        
       list(FIND THIS_TEST_DEPENDS_ALL ${libname} DEPDEP_INDEX)
       if (DEPDEP_INDEX EQUAL -1)
         list(APPEND THIS_TEST_DEPENDS_ALL ${libname})
         set(ADDED_DEPS TRUE)
       endif()
        string(TOUPPER "BOOST_${libname}_DEPENDS" THIS_PROJECT_DEPENDS)
       # message(STATUS "${additional_lib}: ===> ${${THIS_PROJECT_DEPENDS}}")
        set(ADDED_DEPS TRUE)
        while (ADDED_DEPS)
          set(ADDED_DEPS FALSE)
          foreach(DEP ${THIS_TEST_DEPENDS_ALL})
            string(TOUPPER "BOOST_${DEP}_DEPENDS" DEP_DEPENDS)
            foreach(DEPDEP ${${DEP_DEPENDS}})
              list(FIND THIS_TEST_DEPENDS_ALL ${DEPDEP} DEPDEP_INDEX)
              if (DEPDEP_INDEX EQUAL -1)
                list(APPEND THIS_TEST_DEPENDS_ALL ${DEPDEP})
                set(ADDED_DEPS TRUE)
              endif()
            endforeach()
          endforeach()
        endwhile()
      # message(STATUS "->  Dependencies for ${libname}")
      # message(STATUS "->  THIS_TEST_DEPENDS_ALL: ${THIS_TEST_DEPENDS_ALL}")  
        
    endforeach(libname ${BOOST_TEST_BOOST_DEPENDS})
   foreach (include ${THIS_TEST_DEPENDS_ALL})
      #message(STATUS "include: ${include}")
      include_directories("${Boost_SOURCE_DIR}/libs/${include}/include")
    endforeach (include ${includes})

endmacro(boost_tool_dependencies)
#
###############################################################################

# add_subdirectory(quickbook)
# add_subdirectory(wave)
add_subdirectory(bcp)
add_subdirectory(inspect)

=== doc/src/CMakeLists.txt ===
#
# Copyright Troy D. Straszheim
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
#
if (BUILD_DOCUMENTATION_HTML)
  # Install style sheets and the main Boost logo
  install(FILES boostbook.css docutils.css reference.css ../../boost.png
    DESTINATION share/boost-${BOOST_VERSION}/html)

  # Install images
  install(DIRECTORY images
    DESTINATION share/boost-${BOOST_VERSION}/html
    COMPONENT Core
    PATTERN "CVS" EXCLUDE
    PATTERN ".svn" EXCLUDE)
endif ()

=== libs/algorithm/CMakeLists.txt ===
#
# Copyright Troy D. Straszheim
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
#
#----------------------------------------------------------------------------
# This file was automatically generated from the original CMakeLists.txt file
# Add a variable to hold the headers for the library
set (lib_headers
    algorithm
)

# Add a library target to the build system
boost_library_project(
  algorithm
  #  SRCDIRS 
  TESTDIRS  minmax/test string/test
  HEADERS ${lib_headers}
  #  DOCDIRS 
  DESCRIPTION  "A library of various algorithms."
  MODULARIZED
  AUTHORS  "Pavol Droba <droba -at- topmail.sk>"
           "Herve Bronnimann <hbr -at- poly.edu>"
  #  MAINTAINERS 
)

=== libs/any/CMakeLists.txt ===
#
# Copyright Troy D. Straszheim
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
#
#----------------------------------------------------------------------------
# This file was automatically generated from the original CMakeLists.txt file
# Add a variable to hold the headers for the library
set (lib_headers
    any.hpp
)

# Add a library target to the build system
boost_library_project(
  any
  #  SRCDIRS 
  TESTDIRS  test
  HEADERS ${lib_headers}
  #  DOCDIRS 
  DESCRIPTION  "Safe, generic container for single values of different value types."
  MODULARIZED 
  AUTHORS  "Kevlin Henney"
  MAINTAINERS  "Alexander Nasonov <alexander.nasonov -at- gmail.com>"
)

=== libs/array/CMakeLists.txt ===
#
# Copyright Troy D. Straszheim
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
#
#----------------------------------------------------------------------------
# This file was automatically generated from the original CMakeLists.txt file
# Add a variable to hold the headers for the library
set (lib_headers
    array.hpp
)

# Add a library target to the build system
boost_library_project(
  array
  #  SRCDIRS 
  TESTDIRS  test
  HEADERS ${lib_headers}
  #  DOCDIRS 
  DESCRIPTION  "STL compliant container wrapper for arrays of constant size."
  MODULARIZED 
  AUTHORS  "Nicolai Josuttis"
  #  MAINTAINERS 
)

=== libs/asio/CMakeLists.txt ===
#
# Copyright Troy D. Straszheim
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
#
#----------------------------------------------------------------------------
# This file was automatically generated from the original CMakeLists.txt file
# Add a variable to hold the headers for the library
set (lib_headers
    asio.hpp
    asio
)

# Add a library target to the build system
boost_library_project(
  asio
  #  SRCDIRS 
  TESTDIRS test
  HEADERS ${lib_headers}
  #  DOCDIRS 
  DESCRIPTION  "Portable networking, including sockets, timers, hostname resolution and socket iostreams."
  MODULARIZED
  AUTHORS  "Chris Kohlhoff <chris -at- kohlhoff.com>"
  #  MAINTAINERS 
)

=== libs/assign/CMakeLists.txt ===
#
# Copyright Troy D. Straszheim
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
#
#----------------------------------------------------------------------------
# This file was automatically generated from the original CMakeLists.txt file
# Add a variable to hold the headers for the library
set (lib_headers
    assign
    assign.hpp
)

# Add a library target to the build system
boost_library_project(
  assign
  #  SRCDIRS 
  TESTDIRS  test
  HEADERS ${lib_headers}
  #  DOCDIRS 
  DESCRIPTION  "Filling containers with constant or generated data has never been easier."
  MODULARIZED 
  AUTHORS  "Thorsten Ottosen <nesotto -at- cs.auc.dk>"
  #  MAINTAINERS 
)

=== libs/bimap/CMakeLists.txt ===
#
# Copyright Troy D. Straszheim
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
#
#----------------------------------------------------------------------------
# This file was automatically generated from the original CMakeLists.txt file
# Add a variable to hold the headers for the library
set (lib_headers
    bimap.hpp
    bimap
)

# Add a library target to the build system
boost_library_project(
  bimap
  #  SRCDIRS 
  TESTDIRS  test
  HEADERS ${lib_headers}
  #  DOCDIRS 
  DESCRIPTION  "Bidirectional map containers"
  MODULARIZED
  AUTHORS  "Matias Capeletto <matias.capeletto -at- gmail.com>"
  #  MAINTAINERS 
)

=== libs/bind/CMakeLists.txt ===
#
# Copyright Troy D. Straszheim
#
# Distributed under the Boost Software License, Version 1.0.
# See http://www.boost.org/LICENSE_1_0.txt
#
#----------------------------------------------------------------------------
# This file was automatically generated from the original CMakeLists.txt file
# Add a variable to hold the headers for the library
set (lib_headers
    bind.hpp
    bind
)

# Add a library target to the build system
boost_library_project(
  bind
  #  SRCDIRS 
  TESTDIRS  test
  HEADERS ${lib_headers}
  #  DOCDIRS 
  DESCRIPTION  "A generalization of the standard functions std::bind1st and std::bind2nd. It supports arbitrary function objects, functions, function pointers, and member function pointers, and is able to bind any argument to a specific value or route input arguments into arbitrary positions."
  MODULARIZED 
  AUTHORS  "Peter Dimov <pdimov -at- mmltd.net>"
  #  MAINTAINERS 
)

=== debian/changelog ===
boost1.40 (1.40.0-6ubuntu1) maverick; urgency=low

  * Merge from debian unstable.  Remaining changes:
    - Keep patch python2.6.4.patch (Boost SVN r53731)
    - Detect gcc atomic intrinsics, needed for arm spinlock:
      - Keep gcc-atomic-intrinsics.patch
      - debian/rules: Keep armel-specific TOOLSET_CONFIG
  * Re-enable mpi. No need to differ from debian now package is in universe.

 -- Andreas Wenning <awen@awen.dk>  Fri, 25 Jun 2010 19:58:37 +0200

boost1.40 (1.40.0-6) unstable; urgency=low

  * Backport changes from 1.41.0-1 through 1.41.0-3 inclusive.

  * patches/date_time_date_formatting_hpp.patch: Change
    std::locale::locale() to std::locale().  Closes: #564863.

  * patches/boost-graph-printf.patch: New.  Include stdio.h, to define
    fprintf() and stderr.  Closes: #562215.
  
  * patches/kfreebsd-thread.patch: New (thanks, Petr Salinger).  Fix
    checks for __GLIBC__ source so that it builds on GNU/kFreeBSD.  

 -- Steve M. Robbins <smr@debian.org>  Mon, 18 Jan 2010 23:19:45 -0600

boost1.40 (1.40.0-5) unstable; urgency=low

  * control:
  * rtupdate:
  * rules: Remove hard-coded python versions (2.4 and 2.5).  Compute
    supported python versions using "pyversions".  Thanks to Jakub Wilk
    for the patch.  Closes: #556924.

  * source/format:
  * control:
  * rules: Switch to source format "3.0 (quilt)".
  
  * patches/gcc-4.patch: New (thanks, Jakub Wilk).  Patch from upstream
    that works around gcc 4 bug by replacing BOOST_MPL_ASSERT by
    BOOST_STATIC_ASSERT in mpi_datatype_oarchive.h.  Closes: #550300,
    #561407.

 -- Steve M. Robbins <smr@debian.org>  Sun, 20 Dec 2009 22:21:54 -0600

boost1.40 (1.40.0-4ubuntu4) lucid; urgency=low

  [ Andrew Mitchell ]
  * Apply patch from SVN r53731 to fix LP: #539049
   - patches/python2.6.4.patch (Boost SVN r53731)

  [ Scott Howard ]
  * Refreshed patches, fixed Andrew's above patch for release.

 -- Scott Howard <showard314@gmail.com>  Sat, 27 Mar 2010 15:57:40 -0400

boost1.40 (1.40.0-4ubuntu3) lucid; urgency=low

  * Detect gcc atomic intrinsics, needed for arm spinlock (LP: #513721)

 -- David Sugar <david.sugar@canonical.com>  Mon, 01 Feb 2010 21:31:34 -0500

boost1.40 (1.40.0-4ubuntu2) lucid; urgency=low

  * Drop the new libboost-graph-parallel completely - it's failing to build
    because it depends on libboost-mpi.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 11 Dec 2009 18:19:25 +0000

boost1.40 (1.40.0-4ubuntu1) lucid; urgency=low

  * Merge from debian testing.  Remaining changes:
  * Drop libboost-mpi from the package: nothing uses this, and we don't want
    to pull all of the mpi packages into main.
  * Update for Lucid Python versions (2.6 instead of 2.4/2.5)
    + debian/control: Update XS-Python-Version
    + debian/rules: Update python version rules
    + debian/rtupdate: Update for Python 2.6
  * debian/patches/gcc-4.4.patch:
    + Patch from upstream SVN to fix FTBFS with gcc 4.4.
      See http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=550300
  * Drop libboost-graph-parallel1.40-dev and libboost-graph-parallel1.40 for
    now
    - The libboost-graph-parallel .so is not being generated for unknown
       reasons and so causes the package to FTBFS
    - Nothing currently in the archive uses it, so it's not essential now
    - This needs fixing before release

 -- Scott Kitterman <scott@kitterman.com>  Wed, 09 Dec 2009 23:55:29 -0500

boost1.40 (1.40.0-4) unstable; urgency=low

  * rtupdate: Don't die if link target doesn't exist.  Update of
    libboost_mpi_python links failed when boost-python but not
    boost-mpi-python installed, causing postinst to fail.  
    Closes: #556625.

 -- Steve M. Robbins <smr@debian.org>  Tue, 17 Nov 2009 20:58:40 -0600

boost1.40 (1.40.0-3) unstable; urgency=low

  * rules: Keep all headers in package libboostX.Y-dev to avoid bugs about
    one boost lib using headers of another boost lib.  Boost is developed
    as a monolith.  Closes: #548503, #553281, #550006.
  
  * control(libboost1.40-dev): Move libboost-python1.40-dev from Depends
    to Suggests; this is possible now that -dev contains all the header
    files.  Closes: #549935.
  
  * patches/boost-build-pythonid.patch: New (thanks, Gaudenz
    Steinlin).  Add --pythonid parameter to the build system to only add
    an identification to Python libraries.

  * control:
  * rtupdate:
  * rules: Build libboost-mpi-python1.40.0 and
    libboost-mpi-python1.40-dev.  Thanks again to Gaudenz Steinlin.
    Closes: #552014.
  
  * patches/hurd-ellint_rd.patch:
  * patches/hurd-execution_monitor.patch: New (thanks, Pino Toscano).
    Patches for building on hurd.  Closes: #552383.

 -- Steve M. Robbins <smr@debian.org>  Sat, 14 Nov 2009 22:44:30 -0600

boost1.40 (1.40.0-2ubuntu3) lucid; urgency=low

  * Drop libboost-mpi from the package: nothing uses this, and we don't want
    to pull all of the mpi packages into main.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 01 Dec 2009 06:07:41 +0000

boost1.40 (1.40.0-2ubuntu2) karmic; urgency=low

  * debian/rules:
    + Only explicitely list non-standard Python version, fixes
      FTBFS for real now.

 -- Sebastian Dröge <slomo@debian.org>  Tue, 20 Oct 2009 21:03:02 +0200

boost1.40 (1.40.0-2ubuntu1) karmic; urgency=low

  * Update for Karmic Python versions (2.5/2.6 instead of 2.4/2.5)
    + debian/control: Update XS-Python-Version
    + debian/rules: Update python version rules
    + debian/rtupdate: Update for Python 2.6
  * debian/patches/gcc-4.4.patch:
    + Patch from upstream SVN to fix FTBFS with gcc 4.4.
      See http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=550300

 -- Sebastian Dröge <slomo@debian.org>  Tue, 20 Oct 2009 11:26:50 +0200

boost1.40 (1.40.0-2) unstable; urgency=low

  * rules:
  * control: New package libboost-graph-parallel (thanks, Mathieu
    Malaterre).  Closes: #549203.

  * [Merge from 1.39.0-5] rules: Rule $(bjam) needs to depend on
    $(QUILT_STAMPFN) because patches/bootstrap.patch modifies script


=== debian/control ===
Source: boost1.40
Homepage: http://www.boost.org/
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Boost Team <pkg-boost-devel@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>, Domenico Andreoli <cavok@debian.org>
Build-Depends: debhelper (>= 7), bison, flex, docbook-to-man, xsltproc, doxygen, zlib1g-dev, libbz2-dev, libicu-dev, python-all-dev, python-support (>= 0.6), mpi-default-dev
Build-Conflicts: boost-build, libopenmpi-dev (= 1.3.2-2)
XS-Python-Version: >= 2.4
Vcs-Browser: http://svn.debian.org/wsvn/pkg-boost/boost/trunk/
Vcs-Svn: svn://svn.debian.org/svn/pkg-boost/boost/trunk
Standards-Version: 3.8.3

Package: libboost1.40-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}, ${shlibs:Depends}, libboost1.40-dev (= ${binary:Version})
Conflicts: libboost-dbg (<< 1.35.0), libboost1.35-dbg, libboost1.36-dbg, libboost1.37-dbg, libboost1.38-dbg, libboost1.39-dbg
Description: Boost C++ Libraries with debug symbols
 This package forms part of the Boost C++ Libraries collection.
 .
 These libraries are built with debug symbols. They are useful to debug
 programs which use Boost. These must be used also at build/link time.

Package: libboost1.40-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}, libstdc++6-4.4-dev | libstdc++-dev
Suggests: libboost1.40-doc, libboost-date-time1.40-dev, libboost-filesystem1.40-dev, libboost-graph-parallel1.40-dev, libboost-graph1.40-dev, libboost-iostreams1.40-dev, libboost-math1.40-dev, libboost-mpi1.40-dev, libboost-program-options1.40-dev, libboost-python1.40-dev, libboost-regex1.40-dev, libboost-serialization1.40-dev, libboost-signals1.40-dev, libboost-system1.40-dev, libboost-test1.40-dev, libboost-thread1.40-dev, libboost-wave1.40-dev, xsltproc, doxygen, docbook-xml (>= 4.2), docbook-xsl (>= 1.73.2), default-jdk (>= 1.4), fop (>= 0.94)
Conflicts: bcp,
 libboost-dev (<< 1.35.0), 
 libboost1.35-dev,
 libboost1.36-dev,
 libboost1.37-dev,
 libboost1.38-dev,
 libboost1.39-dev,
 libboost1.40-dev (<= 1.40.0-2),
 libboost-date-time1.40-dev (<= 1.40.0-2), 
 libboost-filesystem1.40-dev (<= 1.40.0-2), 
 libboost-graph1.40-dev (<= 1.40.0-2), 
 libboost-graph-parallel1.40-dev (<= 1.40.0-2), 
 libboost-iostreams1.40-dev (<= 1.40.0-2), 
 libboost-math1.40-dev (<= 1.40.0-2), 
 libboost-mpi1.40-dev (<= 1.40.0-2), 
 libboost-mpi-python1.40-dev (<= 1.40.0-2), 
 libboost-program-options1.40-dev (<= 1.40.0-2), 
 libboost-python1.40-dev (<= 1.40.0-2), 
 libboost-regex1.40-dev (<= 1.40.0-2), 
 libboost-serialization1.40-dev (<= 1.40.0-2), 
 libboost-signals1.40-dev (<= 1.40.0-2), 
 libboost-system1.40-dev (<= 1.40.0-2), 
 libboost-test1.40-dev (<= 1.40.0-2), 
 libboost-thread1.40-dev (<= 1.40.0-2), 
 libboost-wave1.40-dev (<= 1.40.0-2)
Replaces: bcp
Provides: bcp
Description: Boost C++ Libraries development files
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides headers and the auxiliary tools bcp, inspect,
 boostbook and quickbook.
 .
 For the following subprojects separate packages exist: date-time,
 filesystem, graph, iostreams, math, mpi, program_options, python,
 regex, serialization, signals, system, test, thread, and wave.

Package: libboost1.40-all-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 libboost1.40-dev,
 libboost-date-time1.40-dev, 
 libboost-filesystem1.40-dev, 
 libboost-graph1.40-dev, 
 libboost-graph-parallel1.40-dev, 
 libboost-iostreams1.40-dev, 
 libboost-math1.40-dev, 
 libboost-mpi1.40-dev, 
 libboost-mpi-python1.40-dev, 
 libboost-program-options1.40-dev, 
 libboost-python1.40-dev, 
 libboost-regex1.40-dev, 
 libboost-serialization1.40-dev, 
 libboost-signals1.40-dev, 
 libboost-system1.40-dev, 
 libboost-test1.40-dev, 
 libboost-thread1.40-dev, 
 libboost-wave1.40-dev
Description: Boost C++ Libraries development files (ALL)
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides the complete Boost development environment,
 including all separately-packaged libraries.

Package: libboost1.40-doc
Homepage: http://www.boost.org/libs/
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libboost1.40-dev (>= ${source:Version})
Conflicts: libboost-doc (<< 1.35.0), libboost1.35-doc, libboost1.36-doc, libboost1.37-doc, libboost1.38-doc, libboost1.39-doc
Description: Boost.org libraries documentation
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This is documentation for the libboost1.40-dev package in HTML format.
 Some pages point to header files provided in libboost1.40-dev package,
 so it is suggested to install the latter as well.

Package: libboost-date-time1.40.0
Homepage: http://www.boost.org/libs/date_time/
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: set of date-time libraries based on generic programming concepts
 This package forms part of the Boost C++ Libraries collection.
 .
 These libraries are intended to make programming with dates and times
 almost as simple and natural as programming with strings and integers.

Package: libboost-date-time1.40-dev
Homepage: http://www.boost.org/libs/date_time/
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, libboost1.40-dev (= ${binary:Version}), libboost-date-time1.40.0 (= ${binary:Version}), libboost-serialization1.40-dev (= ${binary:Version})
Conflicts: libboost-date-time-dev (<< 1.35.0), libboost-date-time1.36-dev, libboost-date-time1.37-dev, libboost-date-time1.38-dev, libboost-date-time1.39-dev
Description: set of date-time libraries based on generic programming concepts
 This package forms part of the Boost C++ Libraries collection.
 .
 These libraries are intended to make programming with dates and times
 almost as simple and natural as programming with strings and integers.

Package: libboost-filesystem1.40.0
Homepage: http://boost.org/libs/filesystem/
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: filesystem operations (portable paths, iteration over directories, etc) in C++
 This package forms part of the Boost C++ Libraries collection.
 .
 The Boost Filesystem Library provides portable facilities to query and 
 manipulate paths, files, and directories.  The goal is to
 facilitate portable script-like operations from within C++ programs.

Package: libboost-filesystem1.40-dev
Homepage: http://boost.org/libs/filesystem/
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, libboost1.40-dev (= ${binary:Version}), libboost-filesystem1.40.0 (= ${binary:Version}), libboost-system1.40-dev (= ${binary:Version})
Conflicts: libboost-filesystem-dev (<< 1.35.0), libboost-filesystem1.35-dev, libboost-filesystem1.36-dev, libboost-filesystem1.37-dev, libboost-filesystem1.38-dev, libboost-filesystem1.39-dev
Description: filesystem operations (portable paths, iteration over directories, etc) in C++
 This package forms part of the Boost C++ Libraries collection.
 .
 The Boost Filesystem Library provides portable facilities to query and 
 manipulate paths, files, and directories.  The goal is to
 facilitate portable script-like operations from within C++ programs.

Package: libboost-graph1.40.0
Homepage: http://www.boost.org/libs/graph/
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: graphviz
Description: generic graph components and algorithms in C++
 This package forms part of the Boost C++ Libraries collection.
 .
 Graphs are mathematical abstractions that are useful for solving
 many types of problems in computer science. Consequently, these
 abstractions must also be represented in computer programs. A
 standardized generic interface for traversing graphs is of utmost
 importance to encourage reuse of graph algorithms and data structures.

Package: libboost-graph1.40-dev
Homepage: http://www.boost.org/libs/graph/
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, libboost1.40-dev (= ${binary:Version}), libboost-serialization1.40-dev (= ${binary:Version}), libboost-test1.40-dev (= ${binary:Version})
Recommends: libboost-graph1.40.0 (= ${binary:Version})
Conflicts: libboost-graph-dev (<< 1.35.0), libboost-graph1.35-dev, libboost-graph1.36-dev, libboost-graph1.37-dev, libboost-graph1.38-dev, libboost-graph1.39-dev
Description: generic graph components and algorithms in C++
 This package forms part of the Boost C++ Libraries collection.
 .
 Graphs are mathematical abstractions that are useful for solving
 many types of problems in computer science. Consequently, these
 abstractions must also be represented in computer programs. A
 standardized generic interface for traversing graphs is of utmost
 importance to encourage reuse of graph algorithms and data structures.

Package: libboost-graph-parallel1.40.0
Homepage: http://www.boost.org/libs/graph_parallel/
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: graphviz
Description: generic graph components and algorithms in C++
 This package forms part of the Boost C++ Libraries collection.
 .
 The Parallel Boost Graph Library is an extension to the Boost Graph Library
 (BGL) for parallel and distributed computing. It offers distributed graphs 
 and graph algorithms to exploit coarse-grained parallelism along with 
 parallel algorithms that exploit fine-grained parallelism, while retaining 
 the same interfaces as the (sequential) BGL. Code written using the sequential
 BGL should be easy to parallelize with the parallel BGL.

Package: libboost-graph-parallel1.40-dev
Homepage: http://www.boost.org/libs/graph_parallel/
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, libboost1.40-dev (= ${binary:Version}), libboost-serialization1.40-dev (= ${binary:Version}), libboost-test1.40-dev (= ${binary:Version})
Recommends: libboost-graph-parallel1.40.0 (= ${binary:Version})
Description: generic graph components and algorithms in C++
 This package forms part of the Boost C++ Libraries collection.
 .
 The Parallel Boost Graph Library is an extension to the Boost Graph Library
 (BGL) for parallel and distributed computing. It offers distributed graphs 
 and graph algorithms to exploit coarse-grained parallelism along with 
 parallel algorithms that exploit fine-grained parallelism, while retaining 
 the same interfaces as the (sequential) BGL. Code written using the sequential
 BGL should be easy to parallelize with the parallel BGL.

Package: libboost-iostreams1.40.0
Homepage: http://www.boost.org/libs/iostreams/
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Boost.Iostreams Library
 This package forms part of the Boost C++ Libraries collection.
 .

=== debian/rules ===
#! /usr/bin/make -f

export DH_OPTIONS

# set the number of build jobs
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	JOBS := -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

PKGVERSION = 1.40
SOVERSION = 1.40.0
SHLIBS_VERSION = (>= 1.40.0-1)

# Boost libraries for which we want separate packages
boost_libs := date-time filesystem graph-parallel graph iostreams math \
	mpi mpi-python						       \
	program-options python regex serialization signals system test \
	thread wave

# these are special cases, where shared library has not the same name of the Boost library
boost_lib_math := math_c99 math_c99f math_tr1 math_tr1f
boost_lib_math_long_double := math_c99l math_tr1l
boost_lib_serialization := serialization wserialization
boost_lib_test := prg_exec_monitor unit_test_framework

# These are special cases for suffixes.  Generally come from --pythonid, so begin with a dash.
boost_suffixes_python := $(addprefix -py,$(subst .,,$(shell pyversions -rv)))
boost_suffixes_mpi-python := $(boost_suffixes_python)

# Files that are generated by filtering a template
filtered_files = \
	debian/libboost-doc.doc-base \
	debian/libboost-python-dev.postinst \
	debian/libboost-python-dev.prerm

# Function to map Boost component name to set of shared library names
# Input: Boost component name
# Return: shared library names for the given Boost library
boost_lib = $(if $(boost_lib_$(1)), $(boost_lib_$(1)), $(1))

# Function to map Boost component name to set of suffixes for the library
# Input: Boost component name
# Return: suffixes for the given Boost component
boost_suffixes = $(if $(boost_suffixes_$(1)), $(boost_suffixes_$(1)),"")

# Helpers to make basic and decorated library names
# Input: library, variant, suffix
# Return: base library filename for short or full name
mk_base_name = usr/lib/libboost_$(subst -,_,$(1))$(2)$(3)

# Input: component, variant
# Return: package name for shared library or development
mk_pkg_lib = libboost$(if $(findstring -d,$(2)),$(PKGVERSION)-dbg,-$(1)$(SOVERSION))
mk_pkg_dev = libboost$(if $(findstring -d,$(2)),$(PKGVERSION)-dbg,-$(1)$(PKGVERSION)-dev)

# Helpers to generate debhelper input filenames.
# Input: component, variant
# Return: prefix to debhelper filenames
mk_deb_lib = debian/$(call mk_pkg_lib,$(1),$(2))
mk_deb_dev = debian/$(call mk_pkg_dev,$(1),$(2))

# Helpers that update debhelper .install or .links files
# Input: component, library, variant, suffix
# Output: none
mk_so_files = $(shell echo debian/tmp/$(call mk_base_name,$(2),$(3),$(4)).so.$(SOVERSION) >> $(call mk_deb_lib,$(1),$(3)).install)
mk_a_files = $(shell echo debian/tmp/$(call mk_base_name,$(2),$(3),$(4)).a >> $(call mk_deb_dev,$(1),$(3)).install)
mk_ln_files = $(shell echo $(call mk_base_name,$(2),$(3),$(4)).so.$(SOVERSION) $(call mk_base_name,$(2),$(3),$(4)).so >> $(call mk_deb_dev,$(1),$(3)).links)

# Make compatibility symlinks libfoo-mt --> libfoo
mk_mtso_files = $(shell echo $(call mk_base_name,$(2),$(3),$(4)).so.$(SOVERSION) $(call mk_base_name,$(2),$(3)-mt,$(4)).so >> $(call mk_deb_dev,$(1),$(3)).links)
mk_mta_files = $(shell echo $(call mk_base_name,$(2),$(3),$(4)).a $(call mk_base_name,$(2),$(3)-mt,$(4)).a >> $(call mk_deb_dev,$(1),$(3)).links)

# Function that updates debhelper files for a given library variant
# Input: component, library, variant, suffix
# Output: none
mk_files = $(foreach fn,a so ln mtso mta,$(call mk_$(fn)_files,$(1),$(2),$(3),$(4)))

# helpers to make and install lintian override files

# Input: package, override
add_override = echo $(1): $(2) >> debian/$(1).lintian-overrides;

# Input: override
add_dbg_override = $(call add_override,libboost$(PKGVERSION)-dbg,$(1))
add_dev_override = $(call add_override,libboost$(PKGVERSION)-dev,$(1))
add_doc_override = $(call add_override,libboost$(PKGVERSION)-doc,$(1))

# Input: component, variant, lintian-warning
add_lib_override = $(call add_override,$(call mk_pkg_lib,$(1),$(2)),$(3))
add_libdev_override = $(call add_override,$(call mk_pkg_dev,$(1),$(2)),$(3))

cp_debhelper = for s in doc-base examples postinst prerm README.Debian; do \
	if test -f debian/$(1).$$s; then cp -f debian/$(1).$$s debian/$(2).$$s; fi; done

# Function that updates debhelper files for all library variants shipped.
mk_debhelper_files = \
	$(call add_dbg_override,package-name-doesnt-match-sonames) \
	$(call add_dbg_override,non-dev-pkg-with-shlib-symlink) \
	$(call add_dbg_override,dbg-package-missing-depends) \
	$(call add_dev_override,description-synopsis-starts-with-a-capital-letter) \
	$(call add_dev_override,spelling-error-in-description) \
	$(call add_dev_override,extra-license-file) \
	$(call add_doc_override,description-synopsis-starts-with-a-capital-letter) \
	$(call add_doc_override,extra-license-file) \
	$(call add_libdev_override,python,,description-synopsis-starts-with-a-capital-letter) \
	$(foreach l, $(boost_libs), \
		echo "making debhelper files for $(l)..."; \
		$(call add_lib_override,$(l),,package-name-doesnt-match-sonames) \
		$(foreach ll, $(call boost_lib,$(l)), \
			$(foreach suf, $(call boost_suffixes,$(l)), \
				$(call mk_files,$(l),$(ll),,$(suf)) \
			) \
		) \
	)

TOOLSET_CONFIG="using gcc : : : <compileflags>-D_REENTRANT ;"
BUILD_LONG_DOUBLE = yes

ifeq ($(DEB_BUILD_ARCH), hppa)
TOOLSET_CONFIG="using gcc : : : <compileflags>-D_REENTRANT <compileflags>-mlong-calls <compileflags>-DBOOST_SP_USE_PTHREADS ;"
BUILD_LONG_DOUBLE = no
else ifeq ($(DEB_BUILD_ARCH), arm)
BUILD_LONG_DOUBLE = no
else ifeq ($(DEB_BUILD_ARCH), armel)
TOOLSET_CONFIG="using gcc : : : <compileflags>-D_REENTRANT <compileflags>-DG_ATOMIC_ARM_USE_GCC_INTRINSICS ;"
BUILD_LONG_DOUBLE = no
else ifeq ($(DEB_BUILD_ARCH), mips)
BUILD_LONG_DOUBLE = no
else ifeq ($(DEB_BUILD_ARCH), mipsel)
BUILD_LONG_DOUBLE = no
else ifeq ($(DEB_BUILD_ARCH), sh4)
BUILD_LONG_DOUBLE = no
endif

ifeq ($(BUILD_LONG_DOUBLE), yes)
boost_lib_math += $(boost_lib_math_long_double)
else
JAM_OPT += --disable-long-double
endif

MPI_CONFIG = "using mpi ;"

exampledir = debian/libboost$(PKGVERSION)-doc/usr/share/doc/libboost$(PKGVERSION)-doc/examples
htmldir = debian/libboost$(PKGVERSION)-doc/usr/share/doc/libboost$(PKGVERSION)-doc/HTML
pyste_prefix = $(CURDIR)/debian/libboost-python$(PKGVERSION)-dev/usr
bjam = $(CURDIR)/bjam

# FIXME: find a flag to disable reading /etc/site-config.jam
JAM = $(bjam) $(JOBS) -d2 $(JAM_OPT) --layout=system --user-config=$(CURDIR)/user-config.jam debug-symbols=on

$(bjam):
	./bootstrap.sh --with-icu --prefix=$(CURDIR)/debian/tmp/usr

user-config.jam:
	echo $(TOOLSET_CONFIG) > $@
	echo $(MPI_CONFIG)     >> $@
	for pyver in $(filter-out $(shell pyversions -dv),$(shell pyversions -rv)); do \
		echo "using python : $$pyver : /usr ;" >> $@; \
	done

build: build-stamp
build-stamp: $(bjam) user-config.jam
	dh_testdir

	$(JAM) --without-python                        
	for pyver in $(shell pyversions -rv); do \
	 	pyid=$$(echo $$pyver | tr -d .); \
	 	$(JAM) --with-python --with-mpi --pythonid=py$$pyid python=$$pyver; \
	 	mv stage/lib/mpi.so stage/lib/mpi-py$$pyid.so; \
	done

	cd tools/bcp && $(JAM)
	cd tools/inspect/build && $(JAM)
	cd tools/quickbook && $(JAM)
	cd tools/wave/build && $(JAM)
	cd tools/regression/build && $(JAM)
	cd libs/python/pyste/install && python setup.py build

	touch build-stamp

$(filtered_files): % : %.in
	sed -e 's/@PKGVERSION@/$(PKGVERSION)/g' < $< > $@

clean-debhelper:
	rm -rf debian/*.install
	rm -rf debian/*.links
	rm -rf debian/*.lintian-overrides

clean: clean-debhelper
	dh_testdir
	dh_testroot
	rm -f build-stamp

	-cd tools && $(JAM) clean
	-$(JAM) clean
	-cd libs/python/pyste/install && python setup.py clean

	rm -rf libs/python/pyste/install/build
	rm -rf tools/jam/src/bootstrap
	rm -rf tools/jam/src/bin.*
	rm -ff tools/jam/src/bjam
	rm -rf tools/regression/build/bin
	rm -rf bin.v2 dist
	rm -rf user-config.jam

	dh_clean build-stamp

# This rule is for debugging debian/rules.
make-debhelper: clean-debhelper
